-- main for star.love

function love.load()
	gr, li, ky				= love.graphics, love.image, love.keyboard
	pi, sin, cos 			= math.pi, math.sin, math.cos
	gr.setCaption( 'Star With Effect' )
	smallfont				= gr.newFont(18)
	gr.setFont( smallfont )
	bckgnd					= gr.newImage( 'MyTest1.jpg' )
	image=gr.newImage( 'StarTran.png' )
	im_width, im_height = image:getWidth(), image:getHeight()
	width, height			= gr.getWidth(), gr.getHeight()	-- screen size
	dn = {								-- dn == doughtnut
		angle				= 0,		-- object rotation
		x					= width / 2,-- object location
		y					= height / 2,
		size				= 1,		-- object size (1 = 400,400)
		}
	factor					= 6			-- surface curvature
	load_effect()
	effect:send( 'factor', factor )
	info = {
			"Object Controls",
			"size:",
			"  <q><w>",
			"lighting effect:",
			"  <a><s>",
			"location:",
			"  X: <left><right>",
			"  Y: <up><down>"
			}
	end

function love.draw()
	gr.setColorMode( 'replace' )
	gr.draw( bckgnd )
	gr.setPixelEffect( effect )
		gr.draw(image,dn.x,dn.y,dn.angle,dn.size,dn.size,im_width/2,im_height/2)
		gr.setPixelEffect(  )
	gr.setColorMode( 'modulate' )
	gr.print( 'FPS: '..love.timer.getFPS(), width - 100, 10 )
	key_options()
	show_data()
	end

function love.update( dt )
	dn.angle=dn.angle+dt
	if dn.angle>= 2*pi then dn.angle	= dn.angle - 2*pi	end
	if ky.isDown( 'left' )	then dn.x	= dn.x - 1			end
	if ky.isDown( 'right' )	then dn.x	= dn.x + 1			end
	if ky.isDown( 'up'	)	then dn.y	= dn.y - 1			end
	if ky.isDown( 'down' )	then dn.y	= dn.y + 1			end
	if ky.isDown( 'a' )		then factor = factor>0 and factor -.01 or 0 effect:send( 'factor', factor ) end
	if ky.isDown( 's' )		then factor = factor+.01 effect:send( 'factor', factor ) end
	if ky.isDown( 'w' )		then dn.size= dn.size + .001	end
	if ky.isDown( 'q' )		then dn.size= dn.size > .002	and dn.size - .001 or .001 end
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push( 'quit' ) end
	end

function load_effect()
	effect = love.graphics.newPixelEffect [[
		extern float factor;
		float inner		= 0.2;
		float outer		= 0.5;
		float mid		= 0.35;
		float cnt		= 0.5;	// center of canvas
		vec4 effect(vec4 global_color, Image texture, vec2 tc, vec2 pc )
		{
		vec4 pixel		= Texel(texture, tc);
		float root		= sqrt((cnt-tc.x)*(cnt-tc.x)+(cnt-tc.y)*(cnt-tc.y));
		if (root		<= outer && root >= inner)
			{
			float adj	= 1 - factor * abs( root - mid );	// adjust color intensity
			pixel.r		= clamp( adj * pixel.r, 0, 1 );		// keep colors inbounds
			pixel.g		= clamp( adj * pixel.g, 0, 1 );
			pixel.b		= clamp( adj * pixel.b, 0, 1 );
			pixel.a		= pixel.a;}
			else { pixel.a = 0;}
			//}
		return pixel;
		}
		]]
	end

function key_options()
	gr.setColor( 255, 255, 0, 255 )
	for i = 1, #info do gr.print( info[i], 10, i * 20 ) end
	end

function show_data()
	gr.setColor( 255, 255, 0, 255 )
	data = {
		"Object Settings",
		"X location: "..dn.x,
		"Y location: "..dn.y,
		"size: "..math.floor( 100 * dn.size ) / 100,
		"lighting: "..math.floor( 100 * factor ) / 100,
		"rotation angle: "..math.floor( dn.angle * 180 / pi )
		}
	local x, y = 10, 20
	for i = 1, #data do
		gr.print( data[i], x, i * y + 420 )
		end
	end


